﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;
using System.Reflection;
using System.Reflection.Emit;
using System.Diagnostics;
using Newtonsoft.Json;
using Newtonsoft.Json.Linq;

namespace demo
{
    public delegate void ProcessDelegate(string ip, int pid,string path, bool iscrate);

    public partial class Form1 : Form
    {
        [DllImport("Wuji.dll", EntryPoint = "Initilize", CharSet = CharSet.Unicode)]
        static extern int Initilize_Wuji(string dllname);

        [DllImport("Wuji.dll", EntryPoint = "ShutDown")]
        static extern void Close_Wuji();

        [DllImport("Wuji.dll", EntryPoint = "StartVirtualHard", CharSet = CharSet.Unicode)]
        static extern int StartVirtualHard_Wuji(bool mac, bool disk, bool volume, bool fix, bool fidex, bool processproted);

        [DllImport("Wuji.dll", EntryPoint = "Login")]
        static extern IntPtr Login_Wuji(string name, string password, int type);

        [DllImport("Wuji.dll", EntryPoint = "AddProxyPath")]
        static extern void AddProxyPath_Wuji(string name);

        [DllImport("Wuji.dll", EntryPoint = "AddDeProxyPath", CharSet = CharSet.Unicode)]
        static extern void AddDeProxyPath_Wuji(string name);

        [DllImport("Wuji.dll", EntryPoint = "GetInfo", CharSet = CharSet.Unicode)]
        static extern IntPtr GetInfo_Wuji();

        [DllImport("Wuji.dll", EntryPoint = "ChangeIp", CharSet = CharSet.Unicode)]
        static extern IntPtr ChangeIp_Wuji(int pid);

        [DllImport("Wuji.dll", EntryPoint = "SetExtra", CharSet = CharSet.Unicode)]
        static extern int SetExtra_Wuji(bool enableloacal, bool childproxy, bool localnetenable);

        public bool mac_ = false;
        public bool hard_ = false;
        public bool volume_ = false;
        public bool register_ = false;
        public bool fixchild_ = false;
        public bool processprotecd_ = false;
        public bool iploc_ = false;
        public bool nochild_ = false;
        public bool localnet_ = false;

        public Form1()
        {
            InitializeComponent();
            int error = Initilize_Wuji("wuji.dll");
            if (error != 0)
            {
                MessageBox.Show(error.ToString(), "提示", MessageBoxButtons.YesNo, MessageBoxIcon.Question);
            }
            radioButton1.Checked = true;

            label3.Text = "账户;  线路;   账户信息;";

            listView1.GridLines = true; //显示表格线
            listView1.View = View.Details;//显示表格细节
            listView1.FullRowSelect = true;//是否可以选择行
            listView1.Columns.Add("路径", 420);
            this.listView1.AllowDrop = true;

           

            listView2.GridLines = true; //显示表格线
            listView2.View = View.Details;//显示表格细节
            listView2.FullRowSelect = true;//是否可以选择行
            listView2.Columns.Add("PID", 20);
            listView2.Columns.Add("NAME", 100);
            listView2.Columns.Add("IP", 100);
            listView2.Columns.Add("LOCALTION", 100);
            listView2.Columns.Add("RECVS", 100);
            listView2.Columns.Add("SENDS", 100);
        }

        private void Form1_FormClosed(object sender, FormClosedEventArgs e)
        {
            Close_Wuji();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            string user = textBox1.Text;
            string pass = textBox2.Text;
            if (user == "" || pass == "")
            {
                return;
            }
            IntPtr info;
            if (radioButton1.Checked)
            {
               info =  Login_Wuji(user, pass, 0);
            }
            else
            {
                info = Login_Wuji(user, pass, 1);
            }
            if (info == IntPtr.Zero)
            {
                this.Text = "登录失败";

            }
            else
            {
                string infostr = Marshal.PtrToStringAnsi(info);
                this.Text = infostr;
                timer1.Enabled = true;//设置为truetimer1_Tick实践就会执行，开始计时
                timer1.Interval = 3000;

                timer2.Enabled = true;
                timer2.Interval = 1000;
            }

        }

        private void checkBox1_CheckedChanged(object sender, EventArgs e)
        {
            mac_ = checkBox1.Checked;
            StartVirtualHard_Wuji(mac_, hard_, volume_, register_, fixchild_, processprotecd_);
        }

        private void listView1_DragEnter(object sender, DragEventArgs e)
        {
            if (e.Data.GetDataPresent(DataFormats.FileDrop, false) == true)
            {
                e.Effect = DragDropEffects.All;
            }
        }

        private void listView1_DragDrop(object sender, DragEventArgs e)
        {
            string[] files = (string[])e.Data.GetData(DataFormats.FileDrop);
            foreach (string file in files)
            {
                listView1.Items.Add(file);
                AddProxyPath_Wuji(file);
            }
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
           /*
            if (textBox1.Text == "")
            {
                return;
            }
            IntPtr pRet = GetInfo_Wuji();
            string info = Marshal.PtrToStringAnsi(pRet);
            string allinfo = "账户;" + textBox1.Text + "  "+"线路;";
            if (this.radioButton1.Checked)
            {
                allinfo += "电信   ";
            }
            else
            {
                allinfo += "联通   ";
            }
            allinfo += info;
            this.label3.Text = allinfo;
            */

        }

        private void Form1_Load(object sender, EventArgs e)
        {

        }

        private void timer2_Tick(object sender, EventArgs e)
        {
            listView2.Items.Clear();
            IntPtr pRet = GetInfo_Wuji();
            string info = Marshal.PtrToStringAnsi(pRet);
            //这里获取 所有 代理程序的 信息 格式 pid-name-ip-location|pid-name-ip-location|
            JObject jsonObj = null;
            try
            {
                jsonObj = JObject.Parse(info);
                if (jsonObj.GetValue("data") != null)
                { 
                    JArray jlist = JArray.Parse(jsonObj["data"].ToString());
                    for (int i = 0; i < jlist.Count; ++i)  //遍历JArray  
                    {
                        JObject tempo = JObject.Parse(jlist[i].ToString());
                        string pid = tempo["pid"].ToString();
                        string name = tempo["name"].ToString();
                        string ip = tempo["ip"].ToString();
                        string location = tempo["location"].ToString();
                        string recvstr = tempo["recv"].ToString();
                        string sendstr = tempo["send"].ToString();

                        ListViewItem lvi = new ListViewItem();
                        lvi.Text = pid;
                        lvi.SubItems.Add(name);
                        lvi.SubItems.Add(ip);
                        lvi.SubItems.Add(location);
                        lvi.SubItems.Add(recvstr);
                        lvi.SubItems.Add(sendstr);
                        listView2.Items.Add(lvi);
                    }
                }
            }
            catch(Exception)
            {

            }
            
        }

        private void OutputDebugString(string info)
        {
            throw new NotImplementedException();
        }

        private void checkbox2_CheckedChanged(object sender, EventArgs e)
        {
            processprotecd_ = checkbox2.Checked;
            StartVirtualHard_Wuji(mac_, hard_, volume_, register_, fixchild_, processprotecd_);
        }

        private void checkBox3_CheckedChanged(object sender, EventArgs e)
        {
            hard_ = checkBox3.Checked;
            StartVirtualHard_Wuji(mac_, hard_, volume_, register_, fixchild_, processprotecd_);
        }

        private void checkBox4_CheckedChanged(object sender, EventArgs e)
        {
            volume_ = checkBox4.Checked;
            StartVirtualHard_Wuji(mac_, hard_, volume_, register_, fixchild_, processprotecd_);
        }

        private void checkBox5_CheckedChanged(object sender, EventArgs e)
        {
            register_ = checkBox5.Checked;
            StartVirtualHard_Wuji(mac_, hard_, volume_, register_, fixchild_, processprotecd_);
        }

        private void checkBox6_CheckedChanged(object sender, EventArgs e)
        {
            fixchild_ = checkBox6.Checked;
            StartVirtualHard_Wuji(mac_, hard_, volume_, register_, fixchild_, processprotecd_);
        }

        private void checkBox7_CheckedChanged(object sender, EventArgs e)
        {
            iploc_ = checkBox7.Checked;
            SetExtra_Wuji(iploc_, nochild_, localnet_);
        }

        private void checkBox9_CheckedChanged(object sender, EventArgs e)
        {
            nochild_ = checkBox9.Checked;
            SetExtra_Wuji(iploc_, nochild_, localnet_);
        }

        private void checkBox8_CheckedChanged(object sender, EventArgs e)
        {
            localnet_ = checkBox8.Checked;
            SetExtra_Wuji(iploc_, nochild_, localnet_);
        }
        
    }
}
